Audacious - Bug #357

Cannot resume after pause when server closes connection
October 07, 2013 12:22 - Bogdan Bezpartochnyy

Status: Rejected Start date: October 07, 2013
Priority: Minor Due date:

Assignee: % Done: 0%

Category: Estimated time: 0.00 hour

Target version: 3.5

Affects version: 3.5

Description

Steps to reproduce:

1. Add network MP3 file to the playlist (using HTTP; the HTTP server supports Range)

2. Start playing

3. Pause and wait several seconds

4. Resume

The file keeps playing a few seconds and then the player abruptly switches to a next item in the playlist.

Expected behavior: the MP3 file continues playing.

I'm using the latest Git version on Arch Linux.

History

#1 - October 08, 2013 21:21 - John Lindgren
Link to the MP3 file, please?

#2 - October 08, 2013 22:58 - Bogdan Bezpartochnyy

I think | found the source of the problem. I've discovered that the issue is not specific to MP3s, but also affects any other format, and probably the bug
is in Neon plugin.

The network resource I'm accessing is located on my home LAN, so it is impossible to access from the outside. All | can do is to provide HTTP
headers:

$ curl -l "http://192.168.0.100/store/1.flac"
HTTP/1.1 200 OK

Date: Tue, 08 Oct 2013 23:50:43 GMT
Accept-Ranges: bytes

Content-Type: audio/flac

Last-Modified: Mon, 07 Oct 2013 08:45:09 GMT
Content-Length: 13903586

Connection: close

$ curl HRange:bytes=16 -| "http://192.168.0.100/store/1.flac"
HTTP/1.1 206 Partial Content

Date: Tue, 08 Oct 2013 23:53:13 GMT

Accept-Ranges: bytes

Content-Type: audio/flac

Content-Range: bytes 16-13903585/13903586
Last-Modified: Mon, 07 Oct 2013 08:45:09 GMT
Content-Length: 13903570

Connection: close
#3 - October 09, 2013 14:51 - John Lindgren

Unless the problem is reproducible on a public HTTP server, you are on your own here.

#4 - October 09, 2013 18:15 - Bogdan Bezpartochnyy

| think this is due to "Connection: close". Can't find any public server with such setup. I'll reconfigure my local server, but the problem in the player still
exists.

#5 - October 09, 2013 18:39 - John Lindgren

Bogdan Bezpartochnyy wrote:

... but the problem in the player still exists.

Until you give me a way to reproduce this on a public HTTP server, | have no way of knowing what that "problem" is.

#6 - October 09, 2013 18:57 - Michael Schwendt

Obvious questions: Is it reproducible with 3.4.1 or is it specific to a snapshot from git? What does "audacious -V" print when you reproduce it? How
long is "several seconds"?

| cannot reproduce it with 3.4.1.

Not so obvious question: Is it also reproducible with the following URL?
http://mschwendt.fedorapeople.org/tmp/blackhol.xmp.ogg

#7 - October 10, 2013 12:45 - Bogdan Bezpartochnyy

Yes, | can reproduce it with the above file. Although | waited about 10 minutes after pause, and after resume it kept playing for about 20-30 seconds.

#8 - October 10, 2013 13:19 - Michael Schwendt

You haven't shown the output from "audacious -V" for that yet.

How do you know when you need to wait "about 10 minutes" instead of only "several seconds"?

#9 - October 10, 2013 17:32 - Michael Schwendt

No easy to reproduce, but | could reproduce it with Audacious 3.4.1 and above URL after some random tries. "audacious -V" output:

[...pause...]

[...wait two minutes...]

main.c:540 [do_autosave]: Saving configuration.

[...resume playback...]

[...short time (30 seconds?) later...]

neon: <0x7f05d00010c0> Error while reading from the network

neon: <0x7f05d00010c0> Error while reading from the network. Terminating reader thread
neon: <0x7f05d00010c0> No request to read from, seek gone wrong?
[...next track started...]

probe.c:164 [file_find_decoder]: Probing file:///home/...xxx.0gg.

(-]
#10 - October 10, 2013 18:14 - John Lindgren

Is there a reason to believe that this "Error while reading from the network" is due to a bug and not just an actual network error?

#11 - October 10, 2013 18:30 - Michael Schwendt

Good question. ;) | have no answer yet and don't know what error condition neon has run into.

#12 - October 14, 2013 10:24 - Bogdan Bezpartochnyy
I've investigated the issue a bit. It seems that the error doesn't occur if after resume quickly move the playing position slider to another location.
Using Wireshark | have traced the TCP communication between the player and the server, and obviously server closes TCP connection after some

time of inactivity (I guess the time depends on server's configuration). But if | move the playing position slider right after resume the player
reestablishes the connection from scratch (sending SYN) and it won't fail.

#13 - October 14, 2013 14:53 - Michael Schwendt

It seems that the error doesn't occur if after resume quickly
move the playing position slider to another location.

Yes, because a seek pretty much restarts as you can see here:
https://github.com/audacious-media-player/audacious-plugins/blob/master/src/neon/neon.c#L.1101

#14 - October 15,2013 01:15 - John Lindgren

So the only problem here is that the server is closing the connection? If so, | don't think that's something we can really fix (or should bother to work
around) on the Audacious side.

#15 - October 15, 2013 01:21 - John Lindgren

Another thought: if you want to pause for a long time and force a new TCP connection when you resume, you can just stop the song and restart from
the same position by double-clicking the playlist tab or pressing CTRL-SHIFT-ENTER.

#16 - October 15, 2013 22:20 - Bogdan Bezpartochnyy

Are there any serious drawbacks of establishing a new TCP connection every time a user resumes playing just like during seeking?

#17 - October 15, 2013 23:46 - John Lindgren

Yes. Pause is not supposed to close and reopen any file handles, internet connections, audio devices, etc. If you don't care about performance and
want to reset everything that might fail while paused, use stop instead.

#18 - October 17, 2013 18:26 - John Lindgren
- Subject changed from Playing MP3 files over the network issue to Cannot resume after pause when server closes connection

- Status changed from New to Rejected
